Index: /XIOS/dev/dev_olga/src/parse_expr/filter_expr_node.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/parse_expr/filter_expr_node.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/parse_expr/filter_expr_node.hpp	(revision 1158)
@@ -169,4 +169,211 @@
       boost::scoped_ptr<IFilterExprNode> child1, child2; //!< The field child nodes to which the operator is applied
   };
+
+
+
+ /*!
+   * Expression node corresponding to a ternary operation on a scalar-scalar-field.
+   */
+  class CFilterScalarScalarFieldOpExprNode : public IFilterExprNode
+  {
+    public:
+      /*!
+       * Constructs an expression node corresponding to the specified ternary operation
+       * applied to the provided fields and scalars child nodes.
+       * Note that the child nodes will be destroyed automatically when the parent node
+       * is destroyed.
+       *
+       * \param child1 the scalar child node to which the operator is applied
+       * \param opId the identifier of the operator
+       * \param child2 the scalar child node to which the operator is applied
+       * \param child3 the field child node to which the operator is applied
+      */
+      CFilterScalarScalarFieldOpExprNode(IScalarExprNode* child1, const std::string& opId, IScalarExprNode* child2, IFilterExprNode* child3);
+
+      virtual boost::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
+
+    private:
+      std::string opId; //!< The identifier of the field
+      boost::scoped_ptr<IScalarExprNode> child1; //!< The scalar child node to which the operator is applied
+      boost::scoped_ptr<IScalarExprNode> child2; //!< The scalar child node to which the operator is applied
+      boost::scoped_ptr<IFilterExprNode> child3; //!< The field child node to which the operator is applied
+  };
+
+
+  /*!
+   * Expression node corresponding to a ternary operation on a scalar-field-scalar.
+   */
+  class CFilterScalarFieldScalarOpExprNode : public IFilterExprNode
+  {
+    public:
+      /*!
+       * Constructs an expression node corresponding to the specified ternary operation
+       * applied to the provided fields and scalars child nodes.
+       * Note that the child nodes will be destroyed automatically when the parent node
+       * is destroyed.
+       *
+       * \param child1 the scalar child node to which the operator is applied
+       * \param opId the identifier of the operator
+       * \param child2 the field child node to which the operator is applied
+       * \param child3 the scalar child node to which the operator is applied
+      */
+      CFilterScalarFieldScalarOpExprNode(IScalarExprNode* child1, const std::string& opId, IFilterExprNode* child2, IScalarExprNode* child3);
+
+      virtual boost::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
+
+    private:
+      std::string opId; //!< The identifier of the field
+      boost::scoped_ptr<IScalarExprNode> child1; //!< The scalar child node to which the operator is applied
+      boost::scoped_ptr<IFilterExprNode> child2; //!< The field child node to which the operator is applied
+      boost::scoped_ptr<IScalarExprNode> child3; //!< The scalar child node to which the operator is applied
+  };
+
+
+  /*!
+   * Expression node corresponding to a ternary operation on a scalar-field-field.
+   */
+  class CFilterScalarFieldFieldOpExprNode : public IFilterExprNode
+  {
+    public:
+      /*!
+       * Constructs an expression node corresponding to the specified ternary operation
+       * applied to the provided fields and scalars child nodes.
+       * Note that the child nodes will be destroyed automatically when the parent node
+       * is destroyed.
+       *
+       * \param child1 the scalar child node to which the operator is applied
+       * \param opId the identifier of the operator
+       * \param child2 the field child node to which the operator is applied
+       * \param child3 the field child node to which the operator is applied
+      */
+      CFilterScalarFieldFieldOpExprNode(IScalarExprNode* child1, const std::string& opId, IFilterExprNode* child2, IFilterExprNode* child3);
+
+      virtual boost::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
+
+    private:
+      std::string opId; //!< The identifier of the field
+      boost::scoped_ptr<IScalarExprNode> child1; //!< The scalar child node to which the operator is applied
+      boost::scoped_ptr<IFilterExprNode> child2; //!< The field child node to which the operator is applied
+      boost::scoped_ptr<IFilterExprNode> child3; //!< The field child node to which the operator is applied
+  };
+
+
+
+/*!
+   * Expression node corresponding to a ternary operation on a field-scalar-scalar.
+   */
+  class CFilterFieldScalarScalarOpExprNode : public IFilterExprNode
+  {
+    public:
+      /*!
+       * Constructs an expression node corresponding to the specified ternary operation
+       * applied to the provided fields and scalars child nodes.
+       * Note that the child nodes will be destroyed automatically when the parent node
+       * is destroyed.
+       *
+       * \param child1 the field child node to which the operator is applied
+       * \param opId the identifier of the operator
+       * \param child2 the scalar child node to which the operator is applied
+       * \param child3 the scalar child node to which the operator is applied
+      */
+      CFilterFieldScalarScalarOpExprNode(IFilterExprNode* child1, const std::string& opId, IScalarExprNode* child2, IScalarExprNode* child3);
+
+      virtual boost::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
+
+    private:
+      std::string opId; //!< The identifier of the field
+      boost::scoped_ptr<IFilterExprNode> child1; //!< The field child node to which the operator is applied
+      boost::scoped_ptr<IScalarExprNode> child2; //!< The scalar child node to which the operator is applied
+      boost::scoped_ptr<IScalarExprNode> child3; //!< The scalar child node to which the operator is applied
+  };
+
+
+/*!
+   * Expression node corresponding to a ternary operation on a field-scalar-field.
+   */
+  class CFilterFieldScalarFieldOpExprNode : public IFilterExprNode
+  {
+    public:
+      /*!
+       * Constructs an expression node corresponding to the specified ternary operation
+       * applied to the provided fields and scalars child nodes.
+       * Note that the child nodes will be destroyed automatically when the parent node
+       * is destroyed.
+       *
+       * \param child1 the field child node to which the operator is applied
+       * \param opId the identifier of the operator
+       * \param child2 the scalar child node to which the operator is applied
+       * \param child3 the field child node to which the operator is applied
+      */
+      CFilterFieldScalarFieldOpExprNode(IFilterExprNode* child1, const std::string& opId, IScalarExprNode* child2, IFilterExprNode* child3);
+
+      virtual boost::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
+
+    private:
+      std::string opId; //!< The identifier of the field
+      boost::scoped_ptr<IFilterExprNode> child1; //!< The field child node to which the operator is applied
+      boost::scoped_ptr<IScalarExprNode> child2; //!< The scalar child node to which the operator is applied
+      boost::scoped_ptr<IFilterExprNode> child3; //!< The field child node to which the operator is applied
+  };
+
+  /*!
+   * Expression node corresponding to a ternary operation on a field-field-scalar.
+   */
+  class CFilterFieldFieldScalarOpExprNode : public IFilterExprNode
+  {
+    public:
+      /*!
+       * Constructs an expression node corresponding to the specified ternary operation
+       * applied to the provided fields and scalars child nodes.
+       * Note that the child nodes will be destroyed automatically when the parent node
+       * is destroyed.
+       *
+       * \param child1 the field child node to which the operator is applied
+       * \param opId the identifier of the operator
+       * \param child2 the field child node to which the operator is applied
+       * \param child3 the scalar child node to which the operator is applied
+      */
+      CFilterFieldFieldScalarOpExprNode(IFilterExprNode* child1, const std::string& opId, IFilterExprNode* child2, IScalarExprNode* child3);
+
+      virtual boost::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
+
+    private:
+      std::string opId; //!< The identifier of the field
+      boost::scoped_ptr<IFilterExprNode> child1; //!< The field child node to which the operator is applied
+      boost::scoped_ptr<IFilterExprNode> child2; //!< The field child node to which the operator is applied
+      boost::scoped_ptr<IScalarExprNode> child3; //!< The scalar child node to which the operator is applied
+  };
+
+
+  /*!
+   * Expression node corresponding to a ternary operation on a field-field-field.
+   */
+  class CFilterFieldFieldFieldOpExprNode : public IFilterExprNode
+  {
+    public:
+      /*!
+       * Constructs an expression node corresponding to the specified ternary operation
+       * applied to the provided fields and scalars child nodes.
+       * Note that the child nodes will be destroyed automatically when the parent node
+       * is destroyed.
+       *
+       * \param child1 the field child node to which the operator is applied
+       * \param opId the identifier of the operator
+       * \param child2 the field child node to which the operator is applied
+       * \param child3 the field child node to which the operator is applied
+      */
+      CFilterFieldFieldFieldOpExprNode(IFilterExprNode* child1, const std::string& opId, IFilterExprNode* child2, IFilterExprNode* child3);
+
+      virtual boost::shared_ptr<COutputPin> reduce(CGarbageCollector& gc, CField& thisField) const;
+
+    private:
+      std::string opId; //!< The identifier of the field
+      boost::scoped_ptr<IFilterExprNode> child1; //!< The field child node to which the operator is applied
+      boost::scoped_ptr<IFilterExprNode> child2; //!< The field child node to which the operator is applied
+      boost::scoped_ptr<IFilterExprNode> child3; //!< The field child node to which the operator is applied
+  };
+
+
+
 }
 
Index: /XIOS/dev/dev_olga/src/parse_expr/generate_lex_yacc.sh
===================================================================
--- /XIOS/dev/dev_olga/src/parse_expr/generate_lex_yacc.sh	(revision 1157)
+++ /XIOS/dev/dev_olga/src/parse_expr/generate_lex_yacc.sh	(revision 1158)
@@ -1,2 +1,2 @@
-bison -d yacc_parser.yacc -o yacc_parser.cpp
+bison --verbose -d yacc_parser.yacc -o yacc_parser.cpp
 flex -o lex_parser.cpp -f lex_parser.lex 
